/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.126 by ce107, Fri Aug 5 23:31:56 2005 UTC revision 1.149 by edhill, Thu May 11 20:28:50 2006 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 248  build_cyrus_makedepend()  { Line 256  build_cyrus_makedepend()  {
256      fi      fi
257  }  }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 353  EOF Line 396  EOF
396      else      else
397          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
398          echo "   "$p_FC          echo "   "$p_FC
399          if test "x$FC" = x ; then      fi
400              FC=`echo $p_FC | $AWK '{print $1}'`  
401              echo "  Setting FORTRAN compiler to: "$FC      #  Use the first of the compilers found in the current PATH
402          fi      #  that has a correctly-named optfile
403        if test "x$OPTFILE" = x  -a  "x$FC" = x ; then
404            for i in $p_FC ; do
405                OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406                if test -r $OPTFILE ; then
407                    echo "  Setting OPTFILE to: "$OPTFILE
408                    break
409                fi
410            done
411      fi      fi
412    
413      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
# Line 527  Usage: "$0" [OPTIONS] Line 578  Usage: "$0" [OPTIONS]
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587      -ts | --ts      -ts | --ts
588            Produce timing information per timestep            Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593        -foolad | --foolad
594              Fool the AD code generator
595        -papi | --papi
596              Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599        -hpmt | --hpmt
600              Performance analysis with the HPM Toolkit
601    
602        -gsl | --gsl
603              Use GSL to control floating point rounding and precision
604    
605      -mpi | --mpi      -mpi | --mpi
606            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
# Line 537  Usage: "$0" [OPTIONS] Line 609  Usage: "$0" [OPTIONS]
609            set to PATH. i.e. Include files from \$PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
610            from \$PATH/lib and use binaries from \$PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
611    
612        -es | --es | -embed-source | --embed-source
613              Embed a tarball containing the full source code
614              (including the Makefile, etc.) used to build the
615              executable [off by default]
616    
617      -bash NAME      -bash NAME
618            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
619    
# Line 601  EOF Line 678  EOF
678        call tsub( string )        call tsub( string )
679        end        end
680  EOF  EOF
681      $FC $FFLAGS $DEFINES -c genmake_tcomp.$FS >> genmake_warnings 2>&1      $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
682      RETVAL=$?      RETVAL=$?
683      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
684          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 671  EOF Line 748  EOF
748      RET_C=$?      RET_C=$?
749      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
750        program hello        program hello
751        Real*8 wtime        REAL*8 wtime
752        external cloc        external cloc
753        call cloc(wtime)        call cloc(wtime)
754        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
755        end program hello        end
756  EOF  EOF
757      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1
758      RET_F=$?      RET_F=$?
# Line 689  EOF Line 766  EOF
766  }  }
767    
768    
769    check_HAVE_SIGREG()  {
770        get_fortran_c_namemangling
771        cat <<EOF > genmake_tc_1.c
772    $FC_NAMEMANGLE
773    #include <stdlib.h>
774    #include <stdio.h>
775    #include <signal.h>
776    #include <errno.h>
777    #include <ucontext.h>
778    
779    int * ip;
780    
781    static void killhandler(
782        unsigned int sn, siginfo_t  si, struct ucontext *sc )
783    {
784        *ip = *ip + 1;
785        return;
786    }
787    
788    void FC_NAMEMANGLE(sigreg) (int * aip)
789    {
790        struct sigaction s;
791        ip = aip;
792        s.sa_flags = SA_SIGINFO;
793        s.sa_sigaction = (void *)killhandler;
794        if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
795            printf("Sigaction returned error = %d\n", errno);
796            exit(0);
797        }
798        return;
799    }
800    EOF
801        make genmake_tc_1.o >> genmake_warnings 2>&1
802        RET_C=$?
803        cat <<EOF > genmake_tc_2.$FS
804          program hello
805          integer anint
806          common /iv/ anint
807          external sigreg
808          call sigreg(anint)
809          end
810    EOF
811        echo >> genmake_warnings
812        echo "running: check_HAVE_SIGREG()" >> genmake_warnings
813        cat genmake_tc_2.$FS >> genmake_warnings
814        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
815        echo $COMM >> genmake_warnings
816        $COMM >> genmake_warnings 2>&1
817        RETVAL=$?
818        if test "x$RETVAL" = x0 ; then
819            HAVE_SIGREG=t
820            DEFINES="$DEFINES -DHAVE_SIGREG"
821        fi
822        rm -f genmake_tc*
823    }
824    
825    
826    check_HAVE_SETRLSTK()  {
827        get_fortran_c_namemangling
828        cat <<EOF > genmake_tc_1.c
829    $FC_NAMEMANGLE
830    #include <sys/time.h>
831    #include <sys/resource.h>
832    #include <unistd.h>
833    void FC_NAMEMANGLE(setrlstk) ()
834    {
835        struct rlimit rls;
836        rls.rlim_cur = RLIM_INFINITY;
837        rls.rlim_max = RLIM_INFINITY;
838        setrlimit(RLIMIT_STACK, &rls);
839        return;
840    }
841    EOF
842        make genmake_tc_1.o >> genmake_warnings 2>&1
843        RET_C=$?
844        cat <<EOF > genmake_tc_2.$FS
845          program hello
846          external setrlstk
847          call setrlstk()
848          end
849    EOF
850        echo >> genmake_warnings
851        echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
852        cat genmake_tc_2.$FS >> genmake_warnings
853        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
854        echo $COMM >> genmake_warnings
855        $COMM >> genmake_warnings 2>&1
856        RETVAL=$?
857        if test "x$RETVAL" = x0 ; then
858            HAVE_SETRLSTK=t
859            DEFINES="$DEFINES -DHAVE_SETRLSTK"
860        fi
861        rm -f genmake_tc*
862    }
863    
864    
865  check_HAVE_STAT()  {  check_HAVE_STAT()  {
866      get_fortran_c_namemangling      get_fortran_c_namemangling
867      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
# Line 717  EOF Line 890  EOF
890        integer nbyte        integer nbyte
891        call tfsize(nbyte)        call tfsize(nbyte)
892        print *," HELLO WORLD", nbyte        print *," HELLO WORLD", nbyte
893        end program hello        end
894  EOF  EOF
895      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_tc.log 2>&1      echo >> genmake_warnings
896      RET_F=$?      echo "running: check_HAVE_STAT()" >> genmake_warnings
897      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1      cat genmake_tc_2.$FS >> genmake_warnings
898        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
899        echo $COMM >> genmake_warnings
900        $COMM >> genmake_tc.log 2>&1
901      RETVAL=$?      RETVAL=$?
902      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
903          HAVE_STAT=t          HAVE_STAT=t
# Line 735  check_netcdf_libs()  { Line 911  check_netcdf_libs()  {
911      if test ! "x$SKIP_NETCDF_CHECK" = x ; then      if test ! "x$SKIP_NETCDF_CHECK" = x ; then
912          return          return
913      fi      fi
914      echo "" > genmake_tnc.log      echo >> genmake_warnings
915        echo "running: check_netcdf_libs()" >> genmake_warnings
916      cat <<EOF > genmake_tnc.F      cat <<EOF > genmake_tnc.F
917        program fgennc        program fgennc
918  #include "netcdf.inc"  #include "netcdf.inc"
# Line 753  EOF Line 930  EOF
930        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
931        end        end
932  EOF  EOF
933      echo "Executing:" > genmake_tnc.log      echo "===  genmake_tnc.F  ===" > genmake_tnc.log
934      echo "  $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS" \      cat genmake_tnc.F >> genmake_tnc.log
935          > genmake_tnc.log      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
936      RET_CPP=f      RET_CPP=f
937      $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
938          &&  RET_CPP=t      echo "$COMM" >> genmake_tnc.log
939        $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
940      if test "x$RET_CPP" = xf ; then      if test "x$RET_CPP" = xf ; then
941          echo "  WARNING: CPP failed to pre-process the netcdf test." \          echo "  WARNING: CPP failed to pre-process the netcdf test." \
942              > genmake_tnc.log              >> genmake_tnc.log
943          echo "    Please check that \$INCLUDES is properly set." \          echo "    Please check that \$INCLUDES is properly set." \
944              > genmake_tnc.log              >> genmake_tnc.log
945      fi      fi
946      echo "Executing:" > genmake_tnc.log      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
947      echo "  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS" > genmake_tnc.log      echo "  &&  $LINK -o genmake_tnc.o $LIBS" >> genmake_tnc.log
     echo "  $LINK -o genmake_tnc.o $LIBS" > genmake_tnc.log  
948      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
949          &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1          &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
950      RET_COMPILE=$?      RET_COMPILE=$?
951        cat genmake_tnc.log >> genmake_warnings
952    
953      #EH3  Remove test program execution for machines that either disallow      #EH3  Remove test program execution for machines that either disallow
954      #EH3  execution or cannot support it (eg. cross-compilers)      #EH3  execution or cannot support it (eg. cross-compilers)
# Line 783  EOF Line 961  EOF
961          HAVE_NETCDF=t          HAVE_NETCDF=t
962      else      else
963          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
964          $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \          echo "try again with added '-lnetcdf'" > genmake_tnc.log
965            echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
966            echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
967            echo " &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
968            cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
969              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
970              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
971          RET_COMPILE=$?          RET_COMPILE=$?
972            cat genmake_tnc.log >> genmake_warnings
973          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
974              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
975              HAVE_NETCDF=t              HAVE_NETCDF=t
         else  
             cat genmake_tnc.log >> genmake_warnings  
976          fi          fi
977      fi      fi
978      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 838  NOOPTFLAGS= Line 1019  NOOPTFLAGS=
1019  MPI=  MPI=
1020  MPIPATH=  MPIPATH=
1021  TS=  TS=
1022    PAPIS=
1023    PCLS=
1024    FOOLAD=
1025    PAPI=
1026    PCL=
1027    HPMT=
1028    GSL=
1029    HAVE_TEST_L=
1030    
1031  # DEFINES checked by test compilation or command-line  # DEFINES checked by test compilation or command-line
1032  HAVE_SYSTEM=  HAVE_SYSTEM=
1033  HAVE_FDATE=  HAVE_FDATE=
1034  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1035  HAVE_CLOC=  HAVE_CLOC=
1036    HAVE_SETRLSTK=
1037  HAVE_STAT=  HAVE_STAT=
1038  HAVE_NETCDF=  HAVE_NETCDF=
1039  HAVE_ETIME=  HAVE_ETIME=
# Line 860  BASH= Line 1050  BASH=
1050  PWD=`pwd`  PWD=`pwd`
1051  test "x$MAKE" = x  &&  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1052  test "x$AWK" = x   &&  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1053    EMBED_SRC=
1054  THISHOST=`hostname`  THISHOST=`hostname`
1055  THISCWD=`pwd`  THISCWD=`pwd`
1056  THISDATE=`date`  THISDATE=`date`
# Line 893  TAMC_EXTRA= Line 1084  TAMC_EXTRA=
1084    
1085  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1086  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1087  gm_s2="FC CPP IEEE TS MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL MPI JAM DUMPSTATE STANDARDDIRS"
1088    
1089  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1090  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 1075  for ac_option in "$@" ; do Line 1266  for ac_option in "$@" ; do
1266    
1267          -ts | --ts)          -ts | --ts)
1268              TS=true ;;              TS=true ;;
1269            -papis | --papis)
1270                PAPIS=true ;;
1271            -pcls | --pcls)
1272                PCLS=true ;;
1273            -foolad | --foolad)
1274                FOOLAD=true ;;
1275            -papi | --papi)
1276                PAPI=true ;;
1277            -pcl | --pcl)
1278                PCL=true ;;
1279            -hpmt | --hpmt)
1280                HPMT=true ;;
1281    
1282            -gsl | --gsl)
1283                GSL=true ;;
1284    
1285          -mpi | --mpi)          -mpi | --mpi)
1286              MPI=true ;;              MPI=true ;;
# Line 1103  for ac_option in "$@" ; do Line 1309  for ac_option in "$@" ; do
1309          -ignoretime | -ignore_time | --ignoretime | --ignore_time)          -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1310              IGNORE_TIME="-DIGNORE_TIME" ;;              IGNORE_TIME="-DIGNORE_TIME" ;;
1311    
1312            -es | --es | -embed-source | --embed-source)
1313                EMBED_SRC=t ;;
1314    
1315          -*)          -*)
1316              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
1317              usage              usage
# Line 1301  Error: The command "ln -s" failed -- ple Line 1510  Error: The command "ln -s" failed -- ple
1510  EOF  EOF
1511      exit 1      exit 1
1512  fi  fi
1513    test -L genmake_tlink > /dev/null 2>&1
1514    RETVAL=$?
1515    if test "x$RETVAL" = x0 ; then
1516        HAVE_TEST_L=t
1517    fi
1518  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1519    
1520  #  Check for broken *.F/*.f handling and fix if possible  #  Check for broken *.F/*.f handling and fix if possible
# Line 1313  fi Line 1527  fi
1527    
1528  if test ! "x$TS" = x ; then  if test ! "x$TS" = x ; then
1529        echo "  Turning on timing per timestep"        echo "  Turning on timing per timestep"
1530        DEFINES="$DEFINES -DTIME_PER_TIMESTEP"        if test ! "x$FOOLAD" = x ; then
1531                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1532          else
1533                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1534          fi
1535    fi
1536    if test ! "x$PAPIS" = x ; then
1537          echo "  Turning on PAPI flop summary per timestep"
1538          echo "  Please make sure PAPIINC, PAPILIB are defined"
1539          if test ! "x$FOOLAD" = x ; then
1540                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1541          else
1542                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1543          fi
1544          INCLUDES="$INCLUDES $PAPIINC"
1545          LIBS="$LIBS $PAPILIB"
1546    fi
1547    if test ! "x$PCLS" = x ; then
1548          echo "  Turning on PCL counter summary per timestep"
1549          echo "  Please make sure PCLINC, PCLLIB are defined"
1550          if test ! "x$FOOLAD" = x ; then
1551                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1552          else
1553                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1554          fi
1555          INCLUDES="$INCLUDES $PCLINC"
1556          LIBS="$LIBS $PCLLIB"
1557    fi
1558    if test ! "x$PAPI" = x ; then
1559          if test ! "x$PAPIS" = x ; then
1560              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1561              echo "  Sticking with PAPI flop summary per timestep!"
1562          else
1563              echo "  Turning on performance analysis with PAPI"
1564              echo "  Please make sure PAPIINC, PAPILIB are defined"
1565              DEFINES="$DEFINES -DUSE_PAPI"
1566              INCLUDES="$INCLUDES $PAPIINC"
1567              LIBS="$LIBS $PAPILIB"
1568          fi
1569    fi
1570    if test ! "x$PCL" = x ; then
1571          if test ! "x$PCLS" = x ; then
1572              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1573              echo "  Sticking with PCL flop summary per timestep!"
1574          else
1575              echo "  Turning on performance analysis with PCL"
1576              echo "  Please make sure PCLINC, PCLLIB are defined"
1577              DEFINES="$DEFINES -DUSE_PCL"
1578              INCLUDES="$INCLUDES $PCLINC"
1579              LIBS="$LIBS $PCLLIB"
1580          fi
1581    fi
1582    if test ! "x$HPMT" = x ; then
1583          if test ! "x$PAPI" = x ; then
1584              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1585              echo "  Sticking with PAPI!"
1586          else if test ! "x$PCL" = x ; then
1587              echo "  PCL and the HPM Toolkit cannot co-exist!"
1588              echo "  Sticking with PCL!"
1589          else
1590              echo "  Turning on performance analysis with the HPM Toolkit"
1591              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1592              DEFINES="$DEFINES -DUSE_LIBHPM"
1593              INCLUDES="$INCLUDES $HPMTINC"
1594              LIBS="$LIBS $HPMTLIB"
1595          fi
1596          fi
1597    fi
1598    if test ! "x$GSL" = x ; then
1599          echo "  Turning on use of GSL to control floating point calculations"
1600          echo "  Please make sure GSLINC, GSLLIB are defined"
1601          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1602          INCLUDES="$INCLUDES $GSLINC"
1603          LIBS="$LIBS $GSLLIB"
1604  fi  fi
1605    
1606  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
# Line 1323  cat > genmake_tcomp.$FS <<EOF Line 1610  cat > genmake_tcomp.$FS <<EOF
1610        call system('echo hi')        call system('echo hi')
1611        end        end
1612  EOF  EOF
1613  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1614  RETVAL=$?  RETVAL=$?
1615  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1616      HAVE_SYSTEM=t      HAVE_SYSTEM=t
# Line 1338  rm -f genmake_tcomp* Line 1625  rm -f genmake_tcomp*
1625  printf "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1626  cat > genmake_tcomp.$FS <<EOF  cat > genmake_tcomp.$FS <<EOF
1627        program hello        program hello
1628        CHARACTER(128) string        CHARACTER*(128) string
1629        string = ' '        string = ' '
1630        call fdate( string )        call fdate( string )
1631        print *, string        print *, string
1632        end        end
1633  EOF  EOF
1634  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1635  RETVAL=$?  RETVAL=$?
1636  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1637      HAVE_FDATE=t      HAVE_FDATE=t
# Line 1366  cat > genmake_tcomp.$FS <<EOF Line 1653  cat > genmake_tcomp.$FS <<EOF
1653        print *, tarray        print *, tarray
1654        end        end
1655  EOF  EOF
1656  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1657  RETVAL=$?  RETVAL=$?
1658  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1659      HAVE_ETIME=t      HAVE_ETIME=t
# Line 1384  if test "x$HAVE_CLOC" != x ; then Line 1671  if test "x$HAVE_CLOC" != x ; then
1671      echo "yes"      echo "yes"
1672  else  else
1673      echo "no"      echo "no"
1674        if test "x$EMBED_SRC" = xt ; then
1675            echo "    WARNING: you requested file embedding but it has"
1676            echo "      been disabled since C code cannot be called"
1677            EMBED_SRC=
1678        fi
1679    fi
1680    rm -f genmake_t*
1681    
1682    printf "  Can we unlimit the stack size using $FC...  "
1683    check_HAVE_SETRLSTK
1684    if test "x$HAVE_SETRLSTK" != x ; then
1685        echo "yes"
1686    else
1687        echo "no"
1688    fi
1689    rm -f genmake_t*
1690    
1691    printf "  Can we register a signal handler using $FC...  "
1692    check_HAVE_SIGREG
1693    if test "x$HAVE_SIGREG" != x ; then
1694        echo "yes"
1695    else
1696        echo "no"
1697  fi  fi
1698  rm -f genmake_t*  rm -f genmake_t*
1699    
# Line 1405  else Line 1715  else
1715  fi  fi
1716  DEFINES="$DEFINES $IGNORE_TIME"  DEFINES="$DEFINES $IGNORE_TIME"
1717    
1718    if test "x$EMBED_SRC" = xt ; then
1719        build_embed_encode
1720    fi
1721    if test "x$EMBED_SRC" = xt ; then
1722        ENABLE="$ENABLE embed_files"
1723    fi
1724    
1725    
1726  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1727  printf "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1728  for d in $MODS ; do  for d in $MODS ; do
# Line 1856  for i in $INCLUDEDIRS ; do Line 2174  for i in $INCLUDEDIRS ; do
2174      fi      fi
2175  done  done
2176    
2177    if test ! "x$DIVA" = x ; then
2178        echo "  Creating the pseudo-MPI include directory"
2179        INCLUDES="-I./mpi_headers $INCLUDES"
2180        rm -rf ./mpi_headers
2181        mkdir -p ./mpi_headers
2182    
2183        if test "x$MPIINCLUDEDIR" = x ; then
2184            if test "x$MPIHOME" = x ; then
2185                MPIHOME='/usr'
2186            fi
2187            MPIINCLUDEDIR='$MPIHOME/include'
2188        fi
2189        
2190        if test -r $MPIINCLUDEDIR/mpif.h ; then
2191            for i in $MPI_HEADER_FILES; do
2192                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2193            done
2194    
2195            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2196        else
2197            echo " We cannot create a copy of mpif.h!"
2198            exit -1
2199        fi
2200    fi
2201    
2202  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2203  rm -rf .links.tmp  rm -rf .links.tmp
2204  mkdir .links.tmp  mkdir .links.tmp
2205    touch .links.tmp/foo
2206    if test ! -r ".links.tmp/foo" ; then
2207        echo
2208        echo "ERROR : something is wrong with your directory permissions or"
2209        echo "   your user file-creation mask (\"umask\") since creating a"
2210        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2211        echo "   not working.  Please try setting your umask to something"
2212        echo "   sane such as:"
2213        echo
2214        echo "      umask 0002"
2215        echo
2216        echo "   and please verify that you have the proper permissions for"
2217        echo "   creating sub-directories and then reading files created"
2218        echo "   within them."
2219        echo
2220        exit 1
2221    fi
2222    rm -f .links.tmp/foo
2223  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2224  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2225  printf 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
# Line 1874  for d in $alldirs ; do Line 2235  for d in $alldirs ; do
2235      for sf in $sfiles ; do      for sf in $sfiles ; do
2236          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
2237              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
2238                    ignore_f=f
2239                  case $d/$sf in                  case $d/$sf in
2240                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2241                            ignore_f=t
2242                          ;;                          ;;
2243                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2244                            ignore_f=t
2245                          ;;                          ;;
2246                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2247                            ignore_f=t
2248                          ;;                          ;;
2249                    ./BUILD_INFO.h)                    ./BUILD_INFO.h)
2250                            ignore_f=t
2251                            ;;
2252                      ./EMBEDDED_FILES.h)
2253                            ignore_f=t
2254                          ;;                          ;;
2255                    *)                    *)
2256                          touch .links.tmp/$sf                          #  For the local directory *ONLY*,
2257                          deplist="$deplist $sf"                          #  ignore all soft-links
2258                            if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2259                                ignore_f=t
2260                            else
2261                                touch .links.tmp/$sf
2262                                deplist="$deplist $sf"
2263                            fi
2264                          ;;                          ;;
2265                  esac                  esac
2266                  extn=`echo $sf | $AWK -F. '{print $NF}'`                  if test "x$ignore_f" = xf ; then
2267                  case $extn in                      extn=`echo $sf | $AWK -F. '{print $NF}'`
2268                      F)                      case $extn in
2269                          echo    " \\"  >> srclist.inc                          F)
2270                          printf " $sf" >> srclist.inc                              echo    " \\"  >> srclist.inc
2271                          ;;                              printf " $sf" >> srclist.inc
2272                      F90)                              ;;
2273                          echo    " \\"  >> f90srclist.inc                          F90)
2274                          printf " $sf" >> f90srclist.inc                              echo    " \\"  >> f90srclist.inc
2275                          ;;                              printf " $sf" >> f90srclist.inc
2276                      c)                              ;;
2277                          echo    " \\"  >> csrclist.inc                          c)
2278                          printf " $sf" >> csrclist.inc                              echo    " \\"  >> csrclist.inc
2279                          ;;                              printf " $sf" >> csrclist.inc
2280                      h)                              ;;
2281                          echo    " \\"  >> hlist.inc                          h)
2282                          printf " $sf" >> hlist.inc                              echo    " \\"  >> hlist.inc
2283                          ;;                              printf " $sf" >> hlist.inc
2284                      flow)                              ;;
2285                          echo    " \\"  >> ad_flow_files.inc                          flow)
2286                          printf " $sf" >> ad_flow_files.inc                              echo    " \\"  >> ad_flow_files.inc
2287                          ;;                              printf " $sf" >> ad_flow_files.inc
2288                  esac                              ;;
2289                        esac
2290                    fi
2291              fi              fi
2292          fi          fi
2293      done      done
# Line 1986  DISABLED_PACKAGES = ${DISABLED_PACKAGES} Line 2363  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2363    
2364  # These files are created by Makefile  # These files are created by Makefile
2365  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2366  EOF  EOF
2367    
2368  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2369        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2370    else
2371        echo "EMBEDDED_FILES = " >>$MAKEFILE
2372    fi
2373    
2374    #  Note: figure out some way to add Hyades JAM libraries here
2375  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2376  # Unix ln (link)  # Unix ln (link)
2377  LN = ${LN}  LN = ${LN}
# Line 2041  cat hlist.inc         >> $MAKEFILE Line 2422  cat hlist.inc         >> $MAKEFILE
2422  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
2423  echo >> $MAKEFILE  echo >> $MAKEFILE
2424  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
2425  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE
2426  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2427  echo >> $MAKEFILE  echo >> $MAKEFILE
2428  echo '.SUFFIXES:' >> $MAKEFILE  echo '.SUFFIXES:' >> $MAKEFILE
# Line 2052  rm -f ad_flow_files.inc Line 2433  rm -f ad_flow_files.inc
2433  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2434    
2435  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2436  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2437          @echo Creating \$@ ...          @echo Creating \$@ ...
2438          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2439  depend:  depend:
# Line 2061  depend: Line 2442  depend:
2442          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2443          -rm -f makedepend.out          -rm -f makedepend.out
2444    
2445    lib: libmitgcmuv.a
2446    
2447    libmitgcmuv.a: \$(OBJFILES)
2448            ar rcv libmitgcmuv.a \$(OBJFILES)
2449    
2450  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2451    
2452  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
# Line 2081  CLEAN: Line 2467  CLEAN:
2467          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2468          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2469          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2470          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) *.txt STD* *diagnostics.log datetime
2471            -rm -rf mnc_test_*
2472    
2473  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2474  makefile:  makefile:
# Line 2109  test ! "x$THISUSER" = x && echo "      -echo Line 2496  test ! "x$THISUSER" = x && echo "      -echo
2496  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2497  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2498    
2499    if test "x$EMBED_SRC" = xt ; then
2500        cat >>$MAKEFILE <<EOF
2501    
2502    decode_files.o : EMBEDDED_FILES.h
2503    
2504    ##  \$(F77FILES)
2505    all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2506            @echo Creating \$@ ...
2507            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2508            -rm -f all_fF.tar.gz
2509            -gzip all_fF.tar
2510    
2511    EMBEDDED_FILES.h : all_fF.tar.gz
2512            @echo Creating \$@ ...
2513            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2514    
2515    EOF
2516    fi
2517    
2518  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2519    
2520  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
# Line 2125  cat >>$MAKEFILE <<EOF Line 2531  cat >>$MAKEFILE <<EOF
2531  .$FS90.o:  .$FS90.o:
2532          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2533  .c.o:  .c.o:
2534          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2535    
2536  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2537  .F.p:  .F.p:

Legend:
Removed from v.1.126  
changed lines
  Added in v.1.149

  ViewVC Help
Powered by ViewVC 1.1.22